---
title: Object.is()
slug: Web/JavaScript/Reference/Global_Objects/Object/is
tags:
  - Comparison
  - Condition
  - Conditional
  - ECMAScript 2015
  - Equality
  - JavaScript
  - Method
  - Object
---
<div>{{JSRef}}</div>

<p>The <strong><code>Object.is()</code></strong> method determines whether two values are <a href="/en-US/docs/Web/JavaScript/Equality_comparisons_and_sameness">the same value</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><code>Object.is(<var>value1</var>, <var>value2</var>);</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>value1</var></code></dt>
 <dd>The first value to compare.</dd>
 <dt><code><var>value2</var></code></dt>
 <dd>The second value to compare.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether or not the two arguments are the same value.</p>

<h2 id="Description">Description</h2>

<p><code>Object.is()</code> determines whether two values are <a href="/en-US/docs/Web/JavaScript/Equality_comparisons_and_sameness">the same value</a>. Two values are the same if one of the following holds:</p>

<ul>
 <li>both {{jsxref("undefined")}}</li>
 <li>both {{jsxref("null")}}</li>
 <li>both <code>true</code> or both <code>false</code></li>
 <li>both strings of the same length with the same characters in the same order</li>
 <li>both the same object (meaning both values reference the same object in memory)</li>
 <li>both numbers and
  <ul>
   <li>both <code>+0</code></li>
   <li>both <code>-0</code></li>
   <li>both {{jsxref("NaN")}}</li>
   <li>or both non-zero and both not {{jsxref("NaN")}} and both have the same value</li>
  </ul>
 </li>
</ul>

<p>This is <em>not</em> the same as being equal according to the {{jsxref("Operators/Comparison_Operators", "==", "#Equality")}} operator. The <code>==</code> operator applies various coercions to both sides (if they are not the same Type) before testing for equality (resulting in such behavior as <code>"" == false</code> being <code>true</code>), but <code>Object.is</code> doesn't coerce either value.</p>

<p>This is also <em>not</em> the same as being equal according to the {{jsxref("Operators/Comparison_Operators", "===", "#Identity")}} operator. The <code>===</code> operator (and the <code>==</code> operator as well) treats the number values <code>-0</code> and <code>+0</code> as equal and treats {{jsxref("Number.NaN")}} as not equal to {{jsxref("NaN")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Object.is">Using Object.is</h3>

<pre class="brush: js notranslate">Object.is('foo', 'foo');     // true
Object.is(window, window);   // true

Object.is('foo', 'bar');     // false
Object.is([], []);           // false

var foo = { a: 1 };
var bar = { a: 1 };
Object.is(foo, foo);         // true
Object.is(foo, bar);         // false

Object.is(null, null);       // true

// Special Cases
Object.is(0, -0);            // false
Object.is(-0, -0);           // true
Object.is(NaN, 0/0);         // true
</pre>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js notranslate">if (!Object.is) {
  Object.defineProperty(Object, "is", {
    value: function (x, y) {
      // SameValue algorithm
      if (x === y) { // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return x !== 0 || 1 / x === 1 / y;
      } else {
        // Step 6.a: NaN == NaN
        return x !== x &amp;&amp; y !== y;
      }
    }
  });
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.is', 'Object.is')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Object.is")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Equality_comparisons_and_sameness">Equality comparisons and sameness</a> — a comparison of all three built-in sameness facilities</li>
</ul>
